import { FluentBundle, FluentVariable } from '@fluent/bundle';
import { T as TranslationWithAttrs, F as FluentVueOptions } from './composition-073652cd.js';
export { u as useFluent } from './composition-073652cd.js';
import '@fluent/bundle/esm/ast';
import 'vue-demi';

type InstallFunction = (vue: unknown) => void;

interface FluentVue {
    /** Current negotiated fallback chain of languages */
    bundles: Iterable<FluentBundle>;
    format: (key: string, value?: Record<string, FluentVariable>) => string;
    formatAttrs: (key: string, value?: Record<string, FluentVariable>) => Record<string, string>;
    formatWithAttrs: (key: string, value?: Record<string, FluentVariable>) => TranslationWithAttrs;
    install: InstallFunction;
}
/**
 * Creates FluentVue instance that can be used on a Vue app.
 *
 * @param options - {@link FluentVueOptions}
 */
declare function createFluentVue(options: FluentVueOptions): FluentVue;

export { FluentVue, createFluentVue };
