"use strict";
var FluentVue = (() => {
  var __create = Object.create;
  var __defProp = Object.defineProperty;
  var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
  var __getOwnPropNames = Object.getOwnPropertyNames;
  var __getProtoOf = Object.getPrototypeOf;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __commonJS = (cb, mod) => function __require() {
    return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
  };
  var __export = (target, all) => {
    for (var name in all)
      __defProp(target, name, { get: all[name], enumerable: true });
  };
  var __copyProps = (to, from, except, desc) => {
    if (from && typeof from === "object" || typeof from === "function") {
      for (let key of __getOwnPropNames(from))
        if (!__hasOwnProp.call(to, key) && key !== except)
          __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
    }
    return to;
  };
  var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
    isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
    mod
  ));
  var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

  // globals:vue-demi
  var require_vue_demi = __commonJS({
    "globals:vue-demi"(exports, module) {
      module.exports = VueDemi;
    }
  });

  // globals:@fluent/bundle
  var require_bundle = __commonJS({
    "globals:@fluent/bundle"(exports, module) {
      module.exports = FluentBundle;
    }
  });

  // src/index.ts
  var src_exports = {};
  __export(src_exports, {
    createFluentVue: () => createFluentVue,
    useFluent: () => useFluent
  });
  var import_vue_demi5 = __toESM(require_vue_demi());

  // node_modules/.pnpm/@fluent+sequence@0.7.0_@fluent+bundle@0.17.1/node_modules/@fluent/sequence/esm/map_sync.js
  function mapBundleSync(bundles, ids) {
    if (!Array.isArray(ids)) {
      return getBundleForId(bundles, ids);
    }
    return ids.map((id) => getBundleForId(bundles, id));
  }
  function getBundleForId(bundles, id) {
    for (const bundle of bundles) {
      if (bundle.hasMessage(id)) {
        return bundle;
      }
    }
    return null;
  }

  // src/util/warn.ts
  function assert(condition, message) {
    if (!condition)
      throw new Error(`[fluent-vue] ${message}`);
  }
  function warn(message, ...args) {
    if (true)
      console.warn(`[fluent-vue] ${message}`, ...args);
  }

  // src/TranslationContext.ts
  var TranslationContext = class {
    constructor(bundles, options) {
      this.options = options;
      this.format = (key, value) => {
        var _a;
        const context = this.getBundle(key);
        const message = this.getMessage(context, key);
        return (_a = this._format(context, message, value)) != null ? _a : key;
      };
      this.formatAttrs = (key, value) => {
        var _a;
        const context = this.getBundle(key);
        const message = this.getMessage(context, key);
        return (_a = this._formatAttrs(context, message, value)) != null ? _a : {};
      };
      this.formatWithAttrs = (key, value) => {
        var _a;
        const context = this.getBundle(key);
        const message = this.getMessage(context, key);
        const formatValue = this._format(context, message, value);
        return {
          value: formatValue != null ? formatValue : key,
          attributes: (_a = this._formatAttrs(context, message, value)) != null ? _a : {},
          hasValue: formatValue !== null
        };
      };
      this.$t = this.format;
      this.$ta = this.formatAttrs;
      this.bundles = bundles;
    }
    getBundle(key) {
      return mapBundleSync(this.bundles.value, key);
    }
    getMessage(bundle, key) {
      const message = bundle == null ? void 0 : bundle.getMessage(key);
      if (message === void 0) {
        this.options.warnMissing(key);
        return null;
      }
      return message;
    }
    formatPattern(bundle, key, message, value) {
      const errors = [];
      const formatted = bundle.formatPattern(message, value, errors);
      for (const error of errors)
        warn(`Error when formatting message with key [${key}]`, error);
      return formatted;
    }
    _format(context, message, value) {
      if (context === null || message === null || message.value === null)
        return null;
      return this.formatPattern(context, message.id, message.value, value);
    }
    _formatAttrs(context, message, value) {
      if (context === null || message === null)
        return null;
      const result = {};
      for (const [attrName, attrValue] of Object.entries(message.attributes))
        result[attrName] = this.formatPattern(context, message.id, attrValue, value);
      return result;
    }
  };

  // src/vue/directive.ts
  var import_vue_demi2 = __toESM(require_vue_demi());

  // src/getContext.ts
  var import_vue_demi = __toESM(require_vue_demi());

  // node_modules/.pnpm/cached-iterable@0.3.0/node_modules/cached-iterable/src/cached_iterable.mjs
  var CachedIterable = class extends Array {
    static from(iterable) {
      if (iterable instanceof this) {
        return iterable;
      }
      return new this(iterable);
    }
  };

  // node_modules/.pnpm/cached-iterable@0.3.0/node_modules/cached-iterable/src/cached_sync_iterable.mjs
  var CachedSyncIterable = class extends CachedIterable {
    constructor(iterable) {
      super();
      if (Symbol.iterator in Object(iterable)) {
        this.iterator = iterable[Symbol.iterator]();
      } else {
        throw new TypeError("Argument must implement the iteration protocol.");
      }
    }
    [Symbol.iterator]() {
      const cached = this;
      let cur = 0;
      return {
        next() {
          if (cached.length <= cur) {
            cached.push(cached.iterator.next());
          }
          return cached[cur++];
        }
      };
    }
    touchNext(count = 1) {
      let idx = 0;
      while (idx++ < count) {
        const last = this[this.length - 1];
        if (last && last.done) {
          break;
        }
        this.push(this.iterator.next());
      }
      return this[this.length - 1];
    }
  };

  // node_modules/.pnpm/cached-iterable@0.3.0/node_modules/cached-iterable/src/cached_async_iterable.mjs
  var CachedAsyncIterable = class extends CachedIterable {
    constructor(iterable) {
      super();
      if (Symbol.asyncIterator in Object(iterable)) {
        this.iterator = iterable[Symbol.asyncIterator]();
      } else if (Symbol.iterator in Object(iterable)) {
        this.iterator = iterable[Symbol.iterator]();
      } else {
        throw new TypeError("Argument must implement the iteration protocol.");
      }
    }
    [Symbol.asyncIterator]() {
      const cached = this;
      let cur = 0;
      return {
        async next() {
          if (cached.length <= cur) {
            cached.push(cached.iterator.next());
          }
          return cached[cur++];
        }
      };
    }
    async touchNext(count = 1) {
      let idx = 0;
      while (idx++ < count) {
        const last = this[this.length - 1];
        if (last && (await last).done) {
          break;
        }
        this.push(this.iterator.next());
      }
      return this[this.length - 1];
    }
  };

  // src/inheritBundle.ts
  var import_bundle = __toESM(require_bundle());
  function inheritBundle(locale, parent) {
    const bundle = new import_bundle.FluentBundle(locale, {
      functions: parent._functions,
      useIsolating: parent._useIsolating,
      transform: parent._transform
    });
    bundle._terms = new Map(parent._terms);
    bundle._messages = new Map(parent._messages);
    return bundle;
  }

  // src/getContext.ts
  function* flatMap(iterable, mapper) {
    for (const item of iterable)
      yield* mapper(item);
  }
  function getContext(rootContext, instance) {
    if (instance == null)
      return rootContext;
    const options = instance.$options;
    const fluent = options.fluent;
    if (fluent == null)
      return rootContext;
    if (options._fluent != null)
      return options._fluent;
    const overriddenBundles = (0, import_vue_demi.computed)(
      () => CachedSyncIterable.from(
        flatMap(
          rootContext.bundles.value,
          (parentBundle) => Object.entries(fluent).map(([locale, resources]) => {
            const locales = locale.split(/[\s+,]/);
            const matchingLocales = parentBundle.locales.filter((bundleLocale) => locales.includes(bundleLocale));
            if (matchingLocales.length === 0)
              return parentBundle;
            const bundle = inheritBundle(locales, parentBundle);
            bundle.addResource(resources, { allowOverrides: true });
            return bundle;
          })
        )
      )
    );
    const context = new TranslationContext(overriddenBundles, rootContext.options);
    options._fluent = context;
    return context;
  }

  // src/vue/dom.ts
  var LOCALIZABLE_ATTRIBUTES = {
    global: ["title", "aria-label", "aria-valuetext", "aria-moz-hint"],
    a: ["download"],
    area: ["download", "alt"],
    input: ["alt", "placeholder"],
    menuitem: ["label"],
    menu: ["label"],
    optgroup: ["label"],
    option: ["label"],
    track: ["label"],
    img: ["alt"],
    textarea: ["placeholder"],
    th: ["abbr"]
  };
  function isAttrNameLocalizable(name, element, explicitlyAllowed = []) {
    if (explicitlyAllowed.includes(name))
      return true;
    const attrName = name.toLowerCase();
    const elemName = element.localName;
    if (LOCALIZABLE_ATTRIBUTES.global.includes(attrName))
      return true;
    if (LOCALIZABLE_ATTRIBUTES[elemName] == null)
      return false;
    if (LOCALIZABLE_ATTRIBUTES[elemName].includes(attrName))
      return true;
    if (element.namespaceURI === "http://www.w3.org/1999/xhtml" && elemName === "input" && attrName === "value") {
      const type = element.type.toLowerCase();
      if (type === "submit" || type === "button" || type === "reset")
        return true;
    }
    return false;
  }

  // src/vue/directive.ts
  function translate(el, fluent, binding) {
    const key = binding.arg;
    if (key === void 0) {
      warn("v-t directive is missing arg with translation key");
      return;
    }
    const translation = fluent.formatWithAttrs(key, binding.value);
    if (translation.hasValue)
      el.textContent = translation.value;
    const allowedAttrs = Object.keys(binding.modifiers);
    for (const [attr, attrValue] of Object.entries(translation.attributes)) {
      if (isAttrNameLocalizable(attr, el, allowedAttrs))
        el.setAttribute(attr, attrValue);
    }
  }
  function createVue3Directive(rootContext) {
    return {
      mounted(el, binding) {
        (0, import_vue_demi2.watchEffect)(() => {
          const context = getContext(rootContext, binding.instance);
          translate(el, context, binding);
        });
      },
      updated(el, binding) {
        const context = getContext(rootContext, binding.instance);
        translate(el, context, binding);
      }
    };
  }
  function createVue2Directive(rootContext) {
    return {
      bind(el, binding, vnode) {
        const context = getContext(rootContext, vnode.context);
        translate(el, context, binding);
      },
      update(el, binding, vnode) {
        const context = getContext(rootContext, vnode.context);
        translate(el, context, binding);
      }
    };
  }

  // src/vue/component.ts
  var import_vue_demi3 = __toESM(require_vue_demi());

  // src/util/camelize.ts
  var camelizeRE = /-(\w)/g;
  function camelize(str) {
    return str.replace(camelizeRE, (_, c) => c.toUpperCase());
  }

  // src/symbols.ts
  var RootContextSymbol = Symbol("root-context");

  // src/vue/component.ts
  function getParentWithFluent(instance) {
    const parent = instance == null ? void 0 : instance.$parent;
    const target = parent == null ? void 0 : parent.$options;
    if (target != null && target.fluent == null)
      return getParentWithFluent(parent);
    return parent;
  }
  var reMarkup = /<|&#?\w+;/;
  var component_default = (0, import_vue_demi3.defineComponent)({
    name: "i18n",
    props: {
      path: { type: String, required: true },
      tag: { type: String, default: "span" },
      args: { type: Object, default: () => ({}) },
      html: { type: Boolean, default: false }
    },
    setup(props, { slots, attrs }) {
      const rootContext = (0, import_vue_demi3.inject)(RootContextSymbol);
      assert(rootContext != null, "i18n component used without installing plugin");
      const instance = (0, import_vue_demi3.getCurrentInstance)();
      const parent = getParentWithFluent(instance == null ? void 0 : instance.proxy);
      const fluent = getContext(rootContext, parent);
      const translation = (0, import_vue_demi3.computed)(() => {
        const fluentParams = Object.assign(
          {},
          props.args,
          ...Object.keys(slots).map((key) => ({
            [key]: `\uFFFF\uFFFE${key}\uFFFF`
          }))
        );
        const result = fluent.formatWithAttrs(props.path, fluentParams);
        const camelizedAttrs = Object.fromEntries(
          Object.entries(result.attributes).map(([key, value]) => [camelize(key), value])
        );
        return {
          value: result.value,
          attributes: camelizedAttrs
        };
      });
      const insertSlots = (text) => {
        return text == null ? void 0 : text.split("\uFFFF").map(
          (text2) => text2.startsWith("\uFFFE") ? slots[text2.replace("\uFFFE", "")](translation.value.attributes) : text2
        );
      };
      const processNode = (node) => {
        if (node.nodeType === 3) {
          return insertSlots(node.nodeValue);
        } else if (node.nodeType === 1) {
          const el = node;
          return (0, import_vue_demi3.h)(
            el.nodeName.toLowerCase(),
            {
              ...Object.fromEntries(
                Array.from(el.attributes).map((attr) => [attr.name, attr.value])
              )
            },
            Array.from(el.childNodes).map((node2) => processNode(node2))
          );
        }
        warn(`Unsupported node type: ${node.nodeType}. If you need support for it, please, create an issue in fluent-vue repository.`);
        return [];
      };
      const children = (0, import_vue_demi3.computed)(() => {
        if (!props.html || !reMarkup.test(translation.value.value))
          return insertSlots(translation.value.value);
        const nodes = fluent.options.parseMarkup(translation.value.value);
        return nodes.map(processNode);
      });
      return () => (0, import_vue_demi3.h)(props.tag, { ...attrs }, children.value);
    }
  });

  // src/util/options.ts
  function defaultMarkupParser(value) {
    assert(typeof DOMParser !== "undefined", "DOMParser is not available. Please provide a custom parseMarkup function.");
    const parser = new DOMParser();
    const doc = parser.parseFromString(value, "text/html");
    const nodes = Array.from(doc.body.childNodes);
    return nodes;
  }
  function defaultWarnMissing(key) {
    warn(`Could not find translation for key [${key}]`);
  }
  function getWarnMissing(options) {
    if (options.warnMissing === true || options.warnMissing == null)
      return defaultWarnMissing;
    else if (options.warnMissing === false)
      return () => {
      };
    else
      return options.warnMissing;
  }
  function resolveOptions(options) {
    var _a;
    return {
      warnMissing: getWarnMissing(options),
      parseMarkup: (_a = options.parseMarkup) != null ? _a : defaultMarkupParser
    };
  }

  // src/composition.ts
  var import_vue_demi4 = __toESM(require_vue_demi());
  function useFluent() {
    const instance = (0, import_vue_demi4.getCurrentInstance)();
    assert(instance != null, "useFluent called outside of setup");
    const rootContext = (0, import_vue_demi4.inject)(RootContextSymbol);
    assert(rootContext != null, "useFluent called without installing plugin");
    return getContext(rootContext, instance.proxy);
  }

  // src/index.ts
  function createFluentVue(options) {
    const bundles = (0, import_vue_demi5.shallowRef)(options.bundles);
    const resolvedOptions = resolveOptions(options);
    const rootContext = new TranslationContext(bundles, resolvedOptions);
    return {
      get bundles() {
        return bundles.value;
      },
      set bundles(value) {
        bundles.value = value;
      },
      format: rootContext.format.bind(rootContext),
      formatAttrs: rootContext.formatAttrs.bind(rootContext),
      formatWithAttrs: rootContext.formatWithAttrs.bind(rootContext),
      install(vue) {
        if (import_vue_demi5.isVue3) {
          const vue3 = vue;
          vue3.provide(RootContextSymbol, rootContext);
          vue3.config.globalProperties.$t = function(key, value) {
            return getContext(rootContext, this).format(key, value);
          };
          vue3.config.globalProperties.$ta = function(key, value) {
            return getContext(rootContext, this).formatAttrs(key, value);
          };
          vue3.directive("t", createVue3Directive(rootContext));
        } else {
          const vue2 = vue;
          vue2.mixin({
            provide() {
              return {
                [RootContextSymbol]: rootContext
              };
            }
          });
          vue2.prototype.$t = function(key, value) {
            return getContext(rootContext, this).format(key, value);
          };
          vue2.prototype.$ta = function(key, value) {
            return getContext(rootContext, this).formatAttrs(key, value);
          };
          vue2.directive("t", createVue2Directive(rootContext));
        }
        vue.component("i18n", component_default);
      }
    };
  }
  return __toCommonJS(src_exports);
})();
